=== debian/changelog ===
libgridxc (2.0.1-1) unstable; urgency=medium

  * New upstream point release.

 -- Michael Banck <mbanck@debian.org>  Fri, 29 Dec 2023 19:51:33 +0100

libgridxc (2.0.0-1) unstable; urgency=medium

  * Initial release.

 -- Michael Banck <mbanck@debian.org>  Sun, 01 Oct 2023 18:31:42 +0200
