=== debian/control ===
Source: libgridxc
Section: libdevel
Priority: optional
Maintainer: Debichem Team <debichem-devel@lists.alioth.debian.org>
Uploaders: Michael Banck <mbanck@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 12),
               gfortran,
               libxc-dev,
               pkg-config
Standards-Version: 4.1.3
Homepage: https://gitlab.com/siesta-project/libraries/libgridxc
Vcs-Browser: https://salsa.debian.org/debichem-team/libgridxc
Vcs-Git: https://salsa.debian.org/debichem-team/ibgridxc.git

Package: libgridxc-dev
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Library to compute exchange/correlation energies (development files)
 libGridXC is a library for the computation of exchange and correlation
 energies and potentials in radial and 3D grids.
 .
 This package contains the static libraries and the header files.
