=== debian/watch ===
version=4
  https://gitlab.com/siesta-project/libraries/libgridxc/tags?sort=updated_desc archive/v?\d[\d.]+/libgridxc-v?([\d.]+)@ARCHIVE_EXT@
