## libgridxc 2.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -12,7 +12,7 @@
 project(
   "libgridxc"
   LANGUAGES "Fortran"
-  VERSION "2.0.1"
+  VERSION "2.0.2"
   DESCRIPTION "Library for XC computation on grids"
 )
