=== debian/changelog ===
libgridxc (2.0.2-1) unstable; urgency=medium

  * New upstream point release.
  * debian/watch: Updated. 
  * debian/control (Vcs-Git): Fixed git url. 

 -- Michael Banck <mbanck@debian.org>  Thu, 14 Nov 2024 20:38:48 +0100
