=== docs/CMakeLists.txt ===
--- 
+++ 
@@ -12,10 +12,10 @@
   DOC "path to the ford executable (required to generate the documentation)"
   )
   
-if(FORD_EXE AND LIBGRIDXC_BUILD_DOCS_FORD)
+if(FORD_EXE)
 
   # for ford pre-processing
-  if(WITH_LIBXC)
+  if(LIBGRIDXC_WITH_LIBXC)
     set(INCLUDE_LIBXC "HAVE_LIBXC")
   else()
     set(INCLUDE_LIBXC "_DUMMY")
@@ -33,7 +33,11 @@
   WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}"
   VERBATIM
   )
- message(STATUS "Done generating documentation")
- 
-  install(DIRECTORY "${FORD_OUTPUT_DIR}/" DESTINATION ${CMAKE_INSTALL_PREFIX}/doc)
+ message(STATUS "Done generating documentation in ${FORD_OUTPUT_DIR}")
+
+  if(LIBGRIDXC_INSTALL)
+    message(STATUS "Installing documentation in ${CMAKE_INSTALL_PREFIX}/doc")
+    install(DIRECTORY "${FORD_OUTPUT_DIR}/" DESTINATION ${CMAKE_INSTALL_PREFIX}/doc)
+  endif()
+  
 endif()
