=== debian/changelog ===
libgridxc (2.1.0-2) unstable; urgency=medium

  * debian/patches/fix_fortran_flags.patch: New patch, removed -march=native
    from Fortran flags. 

 -- Michael Banck <mbanck@debian.org>  Sun, 30 Mar 2025 13:54:54 +0200

libgridxc (2.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Michael Banck <mbanck@debian.org>  Mon, 10 Mar 2025 01:14:37 +0100
