=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
 Standards-Version: 4.1.3
 Homepage: https://gitlab.com/siesta-project/libraries/libgridxc
 Vcs-Browser: https://salsa.debian.org/debichem-team/libgridxc
-Vcs-Git: https://salsa.debian.org/debichem-team/ibgridxc.git
+Vcs-Git: https://salsa.debian.org/debichem-team/libgridxc.git
 
 Package: libgridxc-dev
 Architecture: any
