=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

%:
	dh $@  --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure --                                    \
		-DCMAKE_BUILD_TYPE=${BUILD_TYPE}                \
		-DWITH_LIBXC=YES
