## libgridxc 2.1.0%2Breally2.0.2

=== debian/changelog ===
libgridxc (2.1.0+really2.0.2-1) unstable; urgency=medium

  * Roll back upstream to 2.0.2 release.
  * debian/patches/fix_fortran_flags.patch: Removed, no longer needed. 

 -- Michael Banck <mbanck@debian.org>  Thu, 04 Dec 2025 22:42:34 +0100
